出处:https://leetcode-cn.com/leetbook/read/designing-data-structures/ruunki/

题目描述

请你仅使用两个栈实现先入先出队列。队列应当支持一般队列支持的所有操作(push、pop、peek、empty):
实现 MyQueue 类:

  • void push(int x) 将元素 x 推到队列的末尾
  • int pop() 从队列的开头移除并返回元素
  • int peek() 返回队列开头的元素
  • boolean empty() 如果队列为空,返回 true ;否则,返回 false


    说明:

  • 你只能使用标准的栈操作 —— 也就是只有 push to top, peek/pop from top, size, 和 is empty 操作是合法的。

  • 你所使用的语言也许不支持栈。你可以使用 list 或者 deque(双端队列)来模拟一个栈,只要是标准的栈操作即可。


    进阶:

  • 你能否实现每个操作均摊时间复杂度为 O(1) 的队列?换句话说,执行 n 个操作的总时间复杂度为 O(n) ,即使其中一个操作可能花费较长时间。

示例:

输入: [“MyQueue”, “push”, “push”, “peek”, “pop”, “empty”] [[], [1], [2], [], [], []] 输出: [null, null, null, 1, 1, false]

解释: MyQueue myQueue = new MyQueue(); myQueue.push(1); // queue is: [1] myQueue.push(2); // queue is: [1, 2] (leftmost is front of the queue) myQueue.peek(); // return 1 myQueue.pop(); // return 1, queue is [2] myQueue.empty(); // return false

提示:

  • 1 <= x <= 9
  • 最多调用 100 次 push、pop、peek 和 empty
  • 假设所有操作都是有效的 (例如,一个空的队列不会调用 pop 或者 peek 操作)

    实现格式

    1. class MyQueue {
    2. /** Initialize your data structure here. */
    3. public MyQueue() {
    4. }
    5. /** Push element x to the back of queue. */
    6. public void push(int x) {
    7. }
    8. /** Removes the element from in front of queue and returns that element. */
    9. public int pop() {
    10. }
    11. /** Get the front element. */
    12. public int peek() {
    13. }
    14. /** Returns whether the queue is empty. */
    15. public boolean empty() {
    16. }
    17. }

    题解

    我们创建两个栈,分别为 out 和 in,用作处理「输出」和「输入」操作。
    其实就是两个栈来回「倒腾」。

而对于「何时倒腾」决定了是 O(n) 解法 还是 均摊 O(1)解法。

O(n)解法

我们创建两个栈,分别为 out 和 in:

  • in 用作处理输入操作 push(),使用 in 时需确保 out 为空
  • out 用作处理输出操作 pop() 和 peek(),使用 out 时需确保 in 为空 ```java import java.util.ArrayDeque; import java.util.Deque;

public class MyQueue {

  1. Deque<Integer> out, in;
  2. public MyQueue() {
  3. in = new ArrayDeque<>();
  4. out = new ArrayDeque<>();
  5. }
  6. // 添加一个元素
  7. public void push(int x) {
  8. // out不是空,先把out的元素添加到in
  9. while (!out.isEmpty()) {
  10. in.addLast(out.pollLast());
  11. }
  12. // 最后添加新元素
  13. in.addLast(x);
  14. }
  15. // 移除开头的元素
  16. public int pop() {
  17. // in不是空,把in的元素都添加到到out
  18. while (!in.isEmpty()) {
  19. out.addLast(in.pollLast());
  20. }
  21. // 移除out的最后一个值返回
  22. return out.pollLast();
  23. }
  24. // 返回开头的元素
  25. public int peek() {
  26. // in不是空,把in的元素都添加到到out
  27. while (!in.isEmpty()) {
  28. out.addLast(in.pollLast());
  29. }
  30. // 返回out的最后一个元素
  31. return out.peekLast();
  32. }
  33. public boolean empty() {
  34. // in和out都不是空
  35. return out.isEmpty() && in.isEmpty();
  36. }

}

  1. <a name="N90SY"></a>
  2. ### 均摊O(1)解法
  3. 事实上,我们不需要在每次的「入栈」和「出栈」操作中都进行「倒腾」。<br />我们只需要保证,输入的元素总是跟在前面的输入元素的后面,而输出元素总是最早输入的那个元素即可。
  4. 可以通过调整「倒腾」的时机来确保满足上述要求,但又不需要发生在每一次操作中:
  5. - 只有在「输出栈」为空的时候,才发生一次性的「倒腾」
  6. ```java
  7. import java.util.ArrayDeque;
  8. import java.util.Deque;
  9. public class MyQueue {
  10. Deque<Integer> out, in;
  11. public MyQueue() {
  12. in = new ArrayDeque<>();
  13. out = new ArrayDeque<>();
  14. }
  15. public void push(int x) {
  16. // 直接添加到in
  17. in.addLast(x);
  18. }
  19. public int pop() {
  20. // 当out为空时才进行操作,把in的元素转移到out中
  21. if (out.isEmpty()) {
  22. while (!in.isEmpty()) {
  23. out.addLast(in.pollLast());
  24. }
  25. }
  26. return out.pollLast();
  27. }
  28. public int peek() {
  29. // 当out为空时才进行操作,把in的元素转移到out中
  30. if (out.isEmpty()) {
  31. while (!in.isEmpty()) {
  32. out.addLast(in.pollLast());
  33. }
  34. }
  35. return out.peekLast();
  36. }
  37. public boolean empty() {
  38. // out和in都不为空
  39. return out.isEmpty() && in.isEmpty();
  40. }
  41. }

关于均摊复杂度的说明

我们先用另外一个例子来理解「均摊复杂度」,大家都知道「哈希表」底层是通过数组实现的。
正常情况下,计算元素在哈希桶的位置,然后放入哈希桶,复杂度为 O(1),假定是通过简单的“拉链法”搭配「头插法」方式来解决哈希冲突。

但当某次元素插入后,「哈希表」达到扩容阈值,则需要对底层所使用的数组进行扩容,这个复杂度是 O(n)

显然「扩容」操作不会发生在每一次的元素插入中,因此扩容的 O(n) 都会伴随着 n 次的 O(1),也就是 O(n) 的复杂度会被均摊到每一次插入当中,因此哈希表插入仍然是 O(1) 的。

同理,我们的「倒腾」不是发生在每一次的「输出操作」中,而是集中发生在一次「输出栈为空」的时候,因此 pop 和 peek 都是均摊复杂度为 O(1) 的操作。